<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
    <!-- tokenize -->
    <xsl:template name="tokenize">
        <xsl:param name="string"/>
        <xsl:param name="delimiter"/>
        <xsl:param name="callback"/>
        <xsl:param name="position">1</xsl:param>
        <xsl:choose>
            <xsl:when test="contains($string, $delimiter)">
                <xsl:call-template name="process-token">
                    <xsl:with-param name="token" select="substring-before($string, $delimiter)"/>
                    <xsl:with-param name="position" select="$position"/>
                    <xsl:with-param name="last" select="false()"/>
                    <xsl:with-param name="callback" select="$callback"/>
                </xsl:call-template>
                <xsl:call-template name="tokenize">
                    <xsl:with-param name="string" select="substring-after($string, $delimiter)"/>
                    <xsl:with-param name="delimiter" select="$delimiter"/>
                    <xsl:with-param name="callback" select="$callback"/>
                    <xsl:with-param name="position" select="$position + 1"/>
                </xsl:call-template>
            </xsl:when>
            <xsl:otherwise>
                <xsl:call-template name="process-token">
                    <xsl:with-param name="token" select="$string"/>
                    <xsl:with-param name="position" select="$position"/>
                    <xsl:with-param name="last" select="true()"/>
                    <xsl:with-param name="callback" select="$callback"/>
                </xsl:call-template>
            </xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template name="process-token">
        <xsl:param name="token"/>
        <xsl:param name="position"/>
        <xsl:param name="last"/>
        <xsl:param name="callback"/>
        <xsl:choose>
            <xsl:when test="$callback = ''">
                <!-- process token -->
            </xsl:when>
        </xsl:choose>
    </xsl:template>

    <!-- serialize -->
    <xsl:template match="*" mode="serialize">
        <xsl:param name="indent"><xsl:text>
</xsl:text></xsl:param>
        <xsl:if test="string-length($indent)>1"><xsl:value-of select="$indent"/></xsl:if>&lt;<xsl:value-of select="name()"/>
        <xsl:apply-templates select="@*" mode="serialize"/>
        <xsl:choose>
            <xsl:when test="*">&gt;<xsl:text/>
                <xsl:apply-templates mode="serialize"><xsl:with-param name="indent" select="concat($indent,'    ')"/></xsl:apply-templates>
                <xsl:value-of select="$indent"/>&lt;/<xsl:value-of select="name()"/>&gt;<xsl:text/>
            </xsl:when>
            <xsl:when test="text()|comment()">&gt;<xsl:apply-templates mode="serialize"/>&lt;/<xsl:value-of select="name()"/>&gt;</xsl:when>
            <xsl:otherwise>/&gt;</xsl:otherwise>
        </xsl:choose>
    </xsl:template>
    <xsl:template match="@*" mode="serialize">
        <xsl:text> </xsl:text><xsl:value-of select="name()"/>="<xsl:value-of select="."/>"<xsl:text/>
    </xsl:template>
    <xsl:template match="text()" mode="serialize">
        <xsl:value-of select="normalize-space(.)"/>
    </xsl:template>
    <xsl:template match="comment()" mode="serialize">
        <xsl:comment><xsl:value-of select="."/></xsl:comment>
    </xsl:template>
</xsl:stylesheet>